﻿-- Loot Prio Mouseover

Version="202008221025"
local f = CreateFrame("Frame")
f:RegisterEvent("ADDON_LOADED")
f:RegisterEvent("PLAYER_LOGOUT")
--self.eventFrame:RegisterEvent("CHAT_MSG_ADDON")
--PLAYER_LOGIN

function f:OnEvent(event, arg1, ...)
  if event == "ADDON_LOADED" and arg1 == "LostRabbitsPrio" then
    if LostRabbitsPrio == nil then
      LostRabbitsPrio = defaultLostRabbitsPrio
    end
    if LostRabbitsPrio["Pupdated"] == nil then
      LostRabbitsPrio["Pupdated"]=1
    end
  elseif (event == "CHAT_MSG_ADDON") then
    local msg, distribution, sender = ...;
    if (arg1 == "LRP" and distribution == "GUILD") then
      receiveDataFromGuild(msg)
    elseif (arg1 == "LRPC" and distribution == "GUILD") then
      receiveVerFromGuild(msg)
    end
  elseif event == "PLAYER_ENTERING_WORLD" then
    C_ChatInfo.RegisterAddonMessagePrefix("LRP")
    C_ChatInfo.RegisterAddonMessagePrefix("LRPC")
    local guildname = GetGuildInfo("player")
    for itemId, prio in pairs(LostRabbitsPrio) do
      if string.sub(itemId,1,1)~="P" then 
        item = Item:CreateFromItemID(tonumber(itemId))   
        item:ContinueOnItemLoad(function()                        
          local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType,
          itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(tonumber(itemId));
        end);
      end
    end
    OwnPrioText=getPrioItems(UnitName("player"))
    if guildname=="Lost Rabbits" then
      LostRabbitsPrio["P" .. UnitName("player")]=Version .. "-" .. LostRabbitsPrio["Pupdated"];
    end
    sendDataToGuild()
  end
end

local function SetGameToolTipPrio(tt)
  local container = GetMouseFocus()
  local itemLink = select(2, tt:GetItem())
  if itemLink then
    local _, _, Color, Ltype, Id, Enchant, Gem1, Gem2, Gem3, Gem4, Suffix, Unique, LinkLvl, Name = string.find(itemLink,"|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*):?(%-?%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?")
    iteminfo = select(1, GetItemInfo(itemLink))
    if LostRabbitsPrio[Id] ~= nil then
      tt:AddDoubleLine(LostRabbitsPrio[Id])
    end
  end
end

GameTooltip:HookScript("OnTooltipSetItem", SetGameToolTipPrio)
ItemRefTooltip:HookScript("OnTooltipSetItem", SetGameToolTipPrio)
f:RegisterEvent("CHAT_MSG_ADDON")
f:RegisterEvent("PLAYER_ENTERING_WORLD")
f:RegisterEvent("MODIFIER_STATE_CHANGED")
f:SetScript("OnEvent", f.OnEvent)

function displayImport()
  LRPFrame:Show();
  LRPFrameScroll:Show()
  LRPFrameScrollText:Show()
  LRPFrameScrollText:SetText("")
  LRPFrameScrollText:HighlightText()
  LRPFrameScrollText:SetScript("OnEscapePressed", function(self) self:Hide() end)
  LRPFrameButton1:SetScript("OnClick", function(self) importData(LRPFrameScrollText:GetText()); end);
  LRPFrameButton2:SetScript("OnClick", function(self) LRPFrame:Hide(); end);
  LRPFrameButton3:SetScript("OnClick", function(self) resetList(); end);
end

function displayExport(msg)
  local tmp = createExportRawData(msg)
  LRPFrame:Show();
  LRPFrameScroll:Show()
  LRPFrameScrollText:Show()
  LRPFrameScrollText:SetText(tmp)
  LRPFrameScrollText:HighlightText()
  LRPFrameScrollText:SetScript("OnEscapePressed", function(self) self:Hide() end)
  LRPFrameButton1:Show()
  LRPFrameButton2:Show()
  LRPFrameButton1:SetScript("OnClick", function(self) importData(LRPFrameScrollText:GetText()); end);
  LRPFrameButton2:SetScript("OnClick", function(self) LRPFrame:Hide(); end);
  LRPFrameButton3:SetScript("OnClick", function(self) resetList(); end);
end

function printOwnPrio(arg1)
  if arg1~=nil then
    print("PrioItems für " .. arg1 .. "(bisher " .. getTotalPrioItems(arg1) .. " Items bekommen): " .. getPrioItems(arg1))
  else
    print("Prio für " .. UnitName("player") .. "(bisher " .. UnitName("player") .. " Items bekommen): " .. getPrioItems(UnitName("player")))
  end
end

function getData(arg1)
  local _, _, fct=string.find(arg1,"(%a*)%s")
  if fct=="item" then
    local _, _, _, item, channel = string.find(arg1,"(%a*)%s(%d*)%s?(%a*)")
    local sName, _, _, _, _, _, _, _ = GetItemInfo(tonumber(item))
    tmp=sName 
    tmp=tmp .. getItemPlayer(item)
    channel=""
    if channel~=nil and channel=="raid" then
      SendChatMessage(tmp,"raid")
    else
      print(tmp) 
    end   
  elseif fct=="player" then
    local _, _, tmpfct, name, prio = string.find(arg1,"(%a*)%s(%a*)%s?(%d?)")
    if name==nil then
      name=UnitName("player")
    end
    if prio==nil then
      prio=""
    end
    print(getPrioItems(name) .. "-" .. getTotalPrioItems(name)) 
  end
end

function setData(arg1)
  local _, _, fct=string.find(arg1,"(%a*)%s")
  if fct=="item" then
    local _, _, _, fct2, player, item, prio = string.find(arg1,"(%a*)%s(%a*)%s(%a*)%s(%d*)%s?(%d?)")
    if fct2=="add" then
      assignPlayerToItem(player,item,prio)
    elseif fct2=="remove" then
      removePlayerFromItem(player,item)
    end
  elseif fct=="player" then
    local _, _, tmpfct, player, anz = string.find(arg1,"(%a*)%s(%a*)%s(%d)")
    setTotalPrioItems(player, anz)
  end
end

commandTable = {
  ["import"] = function()
    displayImport()
  end,
  ["export"] = function(arg1)
    displayExport(arg1)
  end,
  ["own"] = function(arg1)
    printOwnPrio(arg1)
  end,
  ["send"] = function(arg1)
    sendDataToGuild(arg1)
  end,
  ["reset"] = function()
    resetList()
  end,
  ["get"] = function(arg1)
    getData(arg1)
  end,
  ["set"] = function(arg1)
    setData(arg1)
  end,
  ["show"] = function()
    createWindow("Lost Rabbits Blau Prios",400,400)
  end,
}

SLASH_LOSTRABBITSPRIO1 = "/lostrabbitsprio"
SLASH_LOSTRABBITSPRIO2 = "/lrp"
SlashCmdList["LOSTRABBITSPRIO"] = function(msg)
  commandExecute(msg) 
end 

function resetList()
  LostRabbitsPrio = {}
  LostRabbitsPrio = defaultLostRabbitsPrio
  LostRabbitsPrio["Pupdated"]=GetServerTime();
end

function commandExecute(text)
  local command, parameters = strsplit(" ", text, 2)
  local entry = commandTable[command:lower()]
  local which = type(entry)
  if which == "function" then
    entry(parameters)
  elseif which == "table" then
    commandExecute(parameters, entry)
  end
end

function setTotalPrioItems(playername, anz)
  anz=tonumber(anz)
  if anz == nil then
    return
  end 
  if anz<0 or anz>5 then
    return
  end
  for key, zeile in pairs(LostRabbitsPrio) do
    if string.find(zeile,playername) ~= nil then
      LostRabbitsPrio[key]=string.gsub(zeile, playername .. "%(%d%)",  playername .. "%(" .. anz .. "%)")
    end
  end
end

function changeInfoFromItem(item, info)
end

function removePlayerFromItem(player, item)
  if item==nil or player==nil then
    return
  end
  sitem=tostring(item) .. ""
  if LostRabbitsPrio[sitem]==nil then
    return
  end
  if string.find(LostRabbitsPrio[sitem], ":" .. player.. "%(%d%)[^,]") then
    LostRabbitsPrio[sitem]=string.gsub(LostRabbitsPrio[sitem], "%d:" .. player .. "%(%d%)\n","")
    LostRabbitsPrio[sitem]=string.gsub(LostRabbitsPrio[sitem], ":%s\n|r",": \n\n|r")
  else
    LostRabbitsPrio[sitem]=string.gsub(LostRabbitsPrio[sitem], player .. "%(%d%),?","")
  end
end

function assignPlayerToItem(player, item, prio)
  if item==nil or player==nil or prio==nil then
    return
  end
  iitem=tostring(item) .. ""
  if LostRabbitsPrio[item]==nil then
    return
  end
  anz = getTotalPrioItems(player)
  if anz==nil then 
    anz=0
  end
  if string.find(LostRabbitsPrio[item], prio .. ":")~= nil then
    LostRabbitsPrio[item]=string.gsub(LostRabbitsPrio[item], prio .. ":", prio .. ":" .. player .. "(" .. anz .. "),")  
  else
    pos=string.find(LostRabbitsPrio[item], "Blau:")+5
    for i=1,6 do
      if i<6 then
        suche=i
      else
        suche="Info"
      end
      pos2=string.find(LostRabbitsPrio[item], suche .. ":")
      if pos2~=nil and prio<=i then 
        break
      end
    end
    if pos2==nil then
      LostRabbitsPrio[item]=string.gsub(LostRabbitsPrio[item],"\n\n", "\n" .. prio .. ":" .. player .. "(" .. anz .. ")\n")
    else
      LostRabbitsPrio[item]=string.sub(LostRabbitsPrio[item],1,pos-1) .. prio .. ":" .. player .. "(" .. anz .. ")\n" .. string.sub(LostRabbitsPrio[item],pos)
    end
  end
end

function getItemPlayer(item)
  tmp = ""
  return LostRabbitsPrio[item]
end

function getTotalPrioItems(playername)
  PlayerPrioText = ""
  for key, zeile in pairs(LostRabbitsPrio) do
    if string.find(zeile,playername) ~= nil then
      pos = string.find(zeile,playername .. "%(") + string.len(playername)
      return string.sub(zeile,pos+1,pos+1)
    end
  end
  return ""
end

function getPrioItems(playername)
local tmp=""
local tablekey=""
local counter=0
  tmpOwnPrio = {}
  PlayerPrioText = ""
  for key, zeile in pairs(LostRabbitsPrio) do
    if string.find(zeile,playername) ~= nil then
      pos = string.find(zeile,":[^:]*" .. playername)
      counter=string.sub(zeile,pos-1,pos-1)
      item = Item:CreateFromItemID(tonumber(key))   
      tmpOwnPrio[counter]=key    
    end
  end
  for key, zeile in orderedPairs(tmpOwnPrio) do
    item = Item:CreateFromItemID(tonumber(zeile))   
    item:ContinueOnItemLoad(function()                        
      local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType,
            itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(tonumber(zeile));
      local r, g, b, hex = GetItemQualityColor(itemRarity)
      tmp="|c" .. hex .. "|Hitem:" .. zeile .. ":::::::::::::::|h[" .. itemName .. "]|h|r"
      PlayerPrioText=PlayerPrioText .. key .. ":" .. tmp .. ", "
    end);
  end
  return PlayerPrioText
end

function receiveDataFromGuild(msg)
  if msg==nil or tonumber(string.sub(msg,1,10))==nil then 
    return
  end
  if LostRabbitsPrio["Pupdated"] == nil then
    LostRabbitsPrio["Pupdated"]=1
  end
  if tonumber(LostRabbitsPrio["Pupdated"])<=tonumber(string.sub(msg,1,10)) then
    LostRabbitsPrio["Pupdated"]=tonumber(string.sub(msg,1,10))
    importData_partly(string.sub(msg,11))
    OwnPrioText=getPrioItems(UnitName("player"))
  end
  local guildname = GetGuildInfo("player")
  if guildname=="Lost Rabbits" then
    LostRabbitsPrio["P" .. UnitName("player")]=Version .. "-" .. LostRabbitsPrio["Pupdated"];
    C_ChatInfo.SendAddonMessage("LRPC", "VER" .. "/" .. UnitName("player") .. "/" .. Version .. "-" .. LostRabbitsPrio["Pupdated"])
  end
end

function receiveVerFromGuild(msg)
  if msg==nil then 
    return
  end
  local _, _, key, ver = string.find(msg, "VER/(.*)/(.*)")
  if key~=nil and ver~=nil then 
    LostRabbitsPrio[key]=ver
  end
end

function sendDataToGuild(arg1)
  if arg1=="push" then
    LostRabbitsPrio["Pupdated"]=GetServerTime();
  end 
  local tmp = createExportRawData("P")
  while string.len(tmp)>0
  do
    local start = string.find(tmp,"\n")
    while start~=nil and start<250
    do
      start2=start
      start = string.find(tmp,"\n",start2+1)
    end
    if start ~= nil then
      C_ChatInfo.SendAddonMessage("LRP", LostRabbitsPrio["Pupdated"] .. string.sub(tmp,1,start2-1), "GUILD")   
    else
      C_ChatInfo.SendAddonMessage("LRP", LostRabbitsPrio["Pupdated"] .. string.sub(tmp,1), "GUILD")
      break
    end 
    if guildname=="Lost Rabbits" then
      C_ChatInfo.SendAddonMessage("LRPC", "VER" .. "/" .. UnitName("player") .. "/" .. Version .. "-" .. LostRabbitsPrio["Pupdated"])
    end
    tmp=string.sub(tmp,start2+1)
  end
end

function createExportRawData(msg)
local tmp=""
  for key, zeile in pairs(LostRabbitsPrio) do
    if string.sub(key,1,1)~="P" or msg=="P" then
      tmp=tmp .. key .. "~"
      for i=1,5 do
        if string.find(zeile,i .. ":[^:]*[\n]") ~= nil then
          local pos, ende = string.find(zeile,i .. ":[^:]*[\n]")
          if ende == nil then
            tmp=tmp .. string.sub(zeile, pos+2) .. ","
          else
            tmp=tmp .. string.sub(zeile, pos+2, ende-1) .. ","
          end
        end
        tmp=tmp .. "~"
      end
      if string.find(zeile,"Info:[^:]*[\n]") ~= nil then
        pos=string.find(zeile,"Info:[^:]*[\n]")
        tmp=tmp .. string.sub(zeile, pos+5, -4) 
      end
      if string.sub(key,1,1)=="P" then
	tmp=tmp .. zeile
      end 
      tmp=tmp .. "####\n"
    end
  end
  return tmp
end 

function importData(arg1)
  LostRabbitsPrio["Pupdated"]=GetServerTime();
  importData_partly(arg1)
end

function importData_partly(arg1)
local tmp=""
local tablekey=""
local counter=0
  if string.sub(arg1,-1,-1) ~= "\n" then
    arg1 = arg1 .. "\n"
  end
  local items = {strsplit("####\n", arg1)} 
  for key, zeile in pairs(items) do
    local item = {strsplit("~", zeile)}
    for key2, attribute in pairs(item) do
      if tablekey == "" then
        tablekey=attribute
      elseif attribute ~= nil and attribute ~= "" then 
	if tmp ~= "" then
          tmp = tmp .. "\n"
        end
        if counter == 6 then 
          if string.sub(attribute,1,5)=="Info:" then
            attribute=string.sub(attribute,6)
          end
          tmp=tmp .. "Info:" .. attribute
        else
          if string.sub(attribute,-1,-1)=="," then
            attribute=string.sub(attribute,1,string.len(attribute)-1)
          end
          tmp=tmp .. counter .. ":" .. attribute
        end
      end
      counter = counter + 1
    end 
    tmp=string.gsub(tmp,"Info:Info:","Info:") -- Bereinigung
    if string.sub(tablekey,1,1)=="P" and tablekey ~= "Pupdated" then 
      LostRabbitsPrio[tablekey]=tmp
    elseif tablekey ~= "" and tablekey ~= "Pupdated" then 
      LostRabbitsPrio[tablekey]="\n|cff6495EDPrio Lost Rabbits Blau: \n" .. tmp .. "\n|r"
    end 
    tmp=""
    tablekey=""
    counter=0
  end 
  OwnPrioText=getPrioItems(UnitName("player"))
end

function __genOrderedIndex( t )
    local orderedIndex = {}
    for key in pairs(t) do
        table.insert( orderedIndex, key )
    end
    table.sort( orderedIndex )
    return orderedIndex
end

function orderedNext(t, state)
    -- Equivalent of the next function, but returns the keys in the alphabetic
    -- order. We use a temporary ordered key table that is stored in the
    -- table being iterated.

    local key = nil
    --print("orderedNext: state = "..tostring(state) )
    if state == nil then
        -- the first time, generate the index
        t.__orderedIndex = __genOrderedIndex( t )
        key = t.__orderedIndex[1]
    else
        -- fetch the next value
        for i = 1,table.getn(t.__orderedIndex) do
            if t.__orderedIndex[i] == state then
                key = t.__orderedIndex[i+1]
            end
        end
    end

    if key then
        return key, t[key]
    end

    -- no more value to return, cleanup
    t.__orderedIndex = nil
    return
end

function orderedPairs(t)
    -- Equivalent of the pairs() function on tables. Allows to iterate
    -- in order
    return orderedNext, t, nil
end

function createWindow(name, height, width)    
    local window = CreateFrame("FRAME", "LostRabbitsPrio", UIParent);        
    window:EnableMouse(true);
    window:SetMovable(true);
    window:SetResizable(false);
    window:SetPoint("CENTER");
	window:SetMinResize(32, 32);
	window:SetSize(height, width);
    window:SetUserPlaced(true);
    window:SetBackdrop(backdrop);
    window:SetBackdropBorderColor(1, 1, 1, 1);
    window:SetBackdropColor(0, 0, 0, 1);
    window:SetClampedToScreen(true);
	window:SetToplevel(true);        
	window:SetScript("OnMouseDown", StartMovingOrSizing);
	window:SetScript("OnMouseUp", StopMovingOrSizing);
	window:SetScript("OnHide", StopMovingOrSizing);

    -- The Close Button. It's assigned as a local variable so you can change how it behaves.
    window.CloseButton = CreateFrame("Button", nil, window, "UIPanelCloseButton");
    window.CloseButton:SetPoint("TOPRIGHT", window, "TOPRIGHT", 4, 3);
    window.CloseButton:SetScript("OnClick", HideParent);        

    return window;
end

function createCheckBox(name, label, parent, x, y, width, height, tooltip, callback)    
    local checkbox = CreateFrame("CheckButton", name, parent, "ChatConfigCheckButtonTemplate");
    checkbox.tooltip = tooltip;    
    checkbox:SetPoint("TOPLEFT", x, y);
--    _G[name.."Text"]:SetSize(width, height);
--   _G[name.."Text"]:SetText(label);    
    checkbox:SetScript("OnClick", callback);

    return checkbox;
end

function createSlider(name, label, parent, min, max, x, y, callback)    
    local slider = CreateFrame("Slider", name, parent, "OptionsSliderTemplate");
    slider:SetPoint("TOPLEFT", x, y);
    slider:SetMinMaxValues(min, max);
    slider:SetWidth(200);
    slider:SetValueStep(1);
    slider:SetStepsPerPage(1);
    slider:SetWidth(200);
    slider:SetObeyStepOnDrag(true);    
    slider:SetScript("OnValueChanged", callback);
--    _G[name.."Text"]:SetText(label);
--    _G[name.."Low"]:SetText(min);
--    _G[name.."High"]:SetText(max);

    return slider;
end
